/*
    cmdline.h - definizione della classe Cmdline per il wrapping di getopt(3)
    Copyright (c) 1997 Simone Govoni
*/

#ifndef CMDLINE_H
#define CMDLINE_H

class Cmdline {
private:
    int optopt;
    int opterr;         // abilita messaggi di errore
    char *opts;         // switch riconosciuti dal programma
    int optind;         // indice del prossimo argomento
    char *optarg;       // puntatore all'argomento dell'opzione corrente
    int argc;           // numero di argomenti della linea di comando
    char **argv;        // argomenti della linea di comando
public:
    /*
        cmdargc: stessa semantica della variabile di sistema argc
        cmdargv: stessa semantica della variabile di sistema argv
        cmdopts: stessa semantica della lista degli switch della funzione
                 getopt() AT&T
    */
    Cmdline(int cmdargc,char *cmdargv[],char *cmdopts)
        :argc(cmdargc),argv(cmdargv),opts(cmdopts),opterr(0),optind(1) { }
    int getopt(void);
    int getoptind(void) const { return optind; }
    char *getoptarg(void) const { return optarg; }
    int getargc(void) const { return argc; }
    char **getargv(void) const { return argv; }
};

#endif // CMDLINE_H