/*
    dbf2html.h - definizione della classe Dbf2HtmlApp
    Copyright (c) 1997 Simone Govoni
*/

/*
    Questo header deve essere incluso DOPO i seguenti file:
    dir.h, dos.h, iostream.h, cmdline.h, applic.h, errhnd, types.h (il mio)
    dbf.h, html.h, fieldlst.h
*/

#ifndef DBF2HTML_H
#define DBF2HTML_H

class Dbf2HtmlApp : public Application, public ErrorHandler {
private:
    enum {MAXEXPSTRING=512};    // lunghezza massima della didascalia o
                                // del titolo espansi

    const char *input_ext;      // estensione da aggiungere ai file in input
    const char *output_ext;     // estensione da aggiungere ai file in output
    Bool sw_deleted;            // corrispondente allo switch /d
    Bool sw_fieldlist;          // corrispondente allo switch /f
    Bool sw_structure;          // corrispondente allo switch /s
    Bool sw_longdate;           // corrispondente allo switch /l
    Bool sw_caption;            // corrispondente allo switch /c
    Bool sw_captbottom;         // corrispondente allo switch /B
    Bool sw_title;              // corrispondente allo switch /t
    char *listarg;              // ptr. all'argomento dello switch /f
    char *captionarg;           // ptr. all'argomento dello switch /c
    char *titlearg;             // ptr. all'argomento dello switch /t
    int border_width;           // larghezza del bordo (switch /b)
    char infile_name[MAXPATH];  // pathname del file in input
    char outfile_name[MAXPATH]; // pathname del file in output
    Dbf *is;                    // stream di input associato al file DBF
    Html *os;                   // stream di output associato al file HTML
    const char *flist_delim;    // carattere usato per separare gli indici da campo
    Fieldlist *flp;             // lista dei campi da includere nella tabella
    Bool fl_allocated;          // TRUE se la lista dei campi e' stata allocata
    Bool dbf_allocated;         // TRUE se e' stato allocato un oggetto Dbf
    Bool html_allocated;        // TRUE se e' stato allocato un oggetto Html
    struct COUNTRY cinfo;       // informazioni dipendenti dalla nazione
    void banner(void);
    void usage(void);
    Bool filter(Html *os,Dbf *is);
    void makefieldlist(void);
    void parsefieldlist(char *cdl);
    Html::Alignmode getalignmode(Dbf::Typecode ftype);
    void expandmacros(char *dest,const char *src,Bool title);
public:
    // argc e argv come passati al main()
    Dbf2HtmlApp(int argc,char *argv[]);
    // main() restituisce il codice da inviare al sistema operativo
    int main(void);
    ~Dbf2HtmlApp();
};

#endif // DBF2HTML_H