/*
    dbstruct.cpp - visualizzazione della struttura di un file DBF
    Copyright (c) 1997 Simone Govoni
*/

#include <fstream.h>
#include <iostream.h>
#include <string.h>
#pragma hdrstop

#include "types.h"
#include "dbf.h"
#include "utility.h"
#include "dbstruct.h"

static char *typedesc(char *s,Dbf::Typecode t);

// Invia sullo stream os la struttura del file DBF associato allo stream is
void printstruct(ostream *os,Dbf *is)
{
    char fname[Dbf::MAX_FIELD_NAME+1];
    char desc[10];
    *os << "\n  #     NAME            TYPE            SIZE\n"
           "--------------------------------------------\n";
    for (int i=1;i<=is->fcount();i++) {
        is->fieldname(fname,i);
        padblanks(fname,Dbf::MAX_FIELD_NAME);
        os->width(3);
        *os << i;
        os->setf(ios::left,ios::adjustfield);
        *os << '\t' << fname << '\t';
        os->width(15);
        *os << typedesc(desc,is->fieldtype(i));
        os->width(5);
        os->setf(ios::right,ios::adjustfield);
        *os << is->fieldsize(i) << '\n';
    }
}


// Espande un codice di tipo in una descrizione estesa
static char *typedesc(char *s,Dbf::Typecode t)
{
    switch (t) {
        case Dbf::CHARACTER:
            strcpy(s,"Character");
            break;
        case Dbf::NUMERIC:
            strcpy(s,"Numeric");
            break;
        case Dbf::LOGICAL:
            strcpy(s,"Logical");
            break;
        case Dbf::DATE:
            strcpy(s,"Date");
            break;
        case Dbf::MEMO:
            strcpy(s,"Memo");
            break;
        case Dbf::UNKNOWN:
            strcpy(s,"Unknown");
            break;
        default:
            break;
    }
    return s;
}
