/*
    errhnd.cpp - gestione degli errori
    Copyright (c) 1997 Simone Govoni
*/

#include <dir.h>
#include <iostream.h>
#include <new.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#pragma hdrstop

#include "errhnd.h"

void out_of_store(void)
{
    cerr << "Fatal error: not enough memory.\n";
    exit(EXIT_FAILURE);
}


ErrorHandler::ErrorHandler(char *pname)
{
    set_new_handler(out_of_store);
    fnsplit(pname,NULL,NULL,progname,NULL);
    strlwr(progname);
}


void ErrorHandler::warning(char *msg,...)
{
    va_list ap;
    va_start(ap,msg);
    char *p;
    cerr << progname << " warning: " << msg << ' ';
    while ((p=va_arg(ap,char *))!=NULL)
        cerr << p << ' ';
    va_end(ap);
    cerr << '\n';
}


void ErrorHandler::fatal(char *msg,...)
{
    va_list ap;
    va_start(ap,msg);
    char *p;
    cerr << progname << " error: " << msg << ' ';
    while ((p=va_arg(ap,char *))!=NULL)
        cerr << p << ' ';
    va_end(ap);
    cerr << '\n';
    exit(EXIT_FAILURE);
}

